<template>
    <div :key="room.id" class="element text-center" :style="getStyle(room)">
        <room :room="room"
        :color="color"
        @room-click="$emit('room-click',room)"
        @update-room="$emit('update-room',room)"></room>
    </div>
</template>

<style scoped>
.v-progress-circular {
margin: 1rem;
}
.element{
    border: 1px ridge black;
    transition: .3s;
    margin:0.05em;
    background-color: white;
}
.element:hover{
    box-shadow:
  0 2.8px 2.2px rgba(0, 0, 0, 0.034),
  0 6.7px 5.3px rgba(0, 0, 0, 0.048),
  0 12.5px 10px rgba(0, 0, 0, 0.06),
  0 22.3px 17.9px rgba(0, 0, 0, 0.072),
  0 41.8px 33.4px rgba(0, 0, 0, 0.086),
  0 100px 80px rgba(0, 0, 0, 0.12);
}
.field{
    margin-top:1em;
    margin-bottom: 1em;
}
</style>

<script>
import Room from "@/components/Room.vue"

export default {
    name: "RoomPlan",
    components:{
        Room
    },
    props: {
        room: {
            type: Object,
            required:true
        }
    },
    data:()=>({
        color:"blue"
    }),
    methods:{
        getStyle(room){
            if (room.curtains.installed&&room.lights.installed) {
                    return{
                    'position': 'absolute',
                    'width': room.width +'px',
                    'height': room.height +'px',
                    'left': room.positionx +25+'px',
                    'top': room.positiony + 'px',
                    'background-color':(room.curtains.value?(room.lights.value==0?'hsl(0,0%,0%)':'hsl(60,'+(40+room.lights.value*3)+'%,60%)'):(room.lights.value==0?'hsl(0,0%,100%)':'hsl(60,'+(40+room.lights.value*3)+'%,60%)')),
                    'color':(room.curtains.value&&room.lights.value==0?'white':'black')
                    }
                }else if(room.lights.installed){
                    return{
                    'position': 'absolute',
                    'width': room.width +'px',
                    'height': room.height +'px',
                    'left': room.positionx +25+'px',
                    'top': room.positiony + 'px', 
                    'background-color':(room.lights.value==0?'hsl(0,0%,100%)':'hsl(60,'+(40+room.lights.value*3)+'%,60%)')
                    }
                }else{
                    return{
                    'position': 'absolute',
                    'width': room.width +'px',
                    'height': room.height +'px',
                    'left': room.positionx +25+'px',
                    'top': room.positiony + 'px',
                    'background-color':'hsl(0,0%,100%)'
                    }
                }
        }
    }
};
</script>